/*
 * node.h
 *
 *  Created on: Nov 5, 2010
 *      Author: troth22s
 */

#ifndef NODE_H_
#define NODE_H_

#include <Data/UniversalContainer.h>
#include <Graph/GraphWrapper.h>
#include <Data/TempBufferRepository.h>

#include <string>

namespace grip {

	using namespace std;

	/**
	 * This header defines the interface to be implemented by the filters
	 */

	/**
	 * @brief The "main" node function.
	 *
	 * This function is called to execute a node, which is itself responsible for retrieving its parameterization. This
	 * can be easily done with the provided GraphWrapper instance and the nodeName. Data can then be retrieved from the
	 * UniversalContainer instance, for which a reference is also passed.
	 */
	extern "C" void run_node(const string& p_nodeName, grip::GraphWrapper& p_gw, grip::UniversalContainer& p_uniCon, grip::TempBufferRepositoryDirectory& p_tbRepoDir);


}

#endif /* NODE_H_ */
