/*
 * Debug.h
 *
 *  Created on: 24.06.2010
 *      Author: troth
 */

/* this should only be included via Common.h, else, behaviour is not defined! */

#ifndef DEBUG_H_
#define DEBUG_H_

#include <iostream>

#define _DEBUG_STR(x)	#x
#define	DEBUG_STR(x)	_DEBUG_STR(x)

// define empty debug message macros
#define DEBUG_MSG_FUNCTIONCALL(x)
#define DEBUG_MSG_RUNTIMEINFO(x)
#define DEBUG_MSG_WARNING(x)	DEBUG_MSG_OUTPUTSTREAM << DEBUG_MSG_PREFIX_RUNTIMEINFO << DEBUG_STR(CLASSNAME) << "::" << x << std::endl

//#define DEBUG

// macro definitions for debug mode
#ifdef DEBUG
	//debug messages
	#if DEBUG_MSG_ACTIVE_FUNCTIONCALL == true
		#undef DEBUG_MSG_FUNCTIONCALL
		#define DEBUG_MSG_FUNCTIONCALL(x) 	DEBUG_MSG_OUTPUTSTREAM << DEBUG_MSG_PREFIX_FUNCTIONCALL << DEBUG_STR(CLASSNAME) << "::" << x << std::endl
	#endif
	#if DEBUG_MSG_ACTIVE_RUNTIMEINFO == true
		#undef DEBUG_MSG_RUNTIMEINFO
		#define DEBUG_MSG_RUNTIMEINFO(x) 	DEBUG_MSG_OUTPUTSTREAM << DEBUG_MSG_PREFIX_RUNTIMEINFO << DEBUG_STR(CLASSNAME) << "::" << x << std::endl
	#endif
	#if DEBUG_MSG_ACTIVE_WARNINGS == true
		#define DEBUG_MSG_WARNING(x)	DEBUG_MSG_OUTPUTSTREAM << DEBUG_MSG_PREFIX_WARNING << DEBUG_STR(CLASSNAME) << "::" << x << std::endl
	#endif
#endif



#endif /* DEBUG_H_ */
