/*
 * HostHelper.h
 *
 *  Created on: 26.01.2012
 *      Author: troth
 */

#ifndef HOSTHELPER_H_
#define HOSTHELPER_H_

#include <stdlib.h>


namespace grip {

/* @brief This is used as a unified way to initialize or get host memory from the temp buffer repository */
void initializeHostBufferFromRepo(void** p_data, grip::TempBufferWrapper** p_theBuffer, grip::TempBufferRepository* p_tbRepo, unsigned int p_widthInBytes, unsigned int p_heightInRows) {
	*p_theBuffer = p_tbRepo->getUsableBuffer(p_widthInBytes, p_heightInRows, grip::ENUM_TBTYPE_HOST);
	if (!*p_theBuffer) {
		cudaMalloc(p_data, p_widthInBytes * p_heightInRows);
		*p_theBuffer = p_tbRepo->addBuffer(*p_data, p_widthInBytes, p_heightInRows, true, grip::ENUM_TBTYPE_HOST);
	} else {
		*p_data = ((*p_theBuffer)->getData());
	}
}


#endif /* HOSTHELPER_H_ */
