/*
 * TimerMacros.h
 *
 *  Created on: Feb 14, 2011
 *      Author: troth22s
 */

#ifndef TIMERMACROS_H_
#define TIMERMACROS_H_

/* timer stuff helping with benchmarks */

#ifdef NODE_BENCHMARK
	#include <sys/time.h>
	#include <iostream>

/** initialize timer with index x */
#define ___GRIP_INITIALIZE_TIMER(x) \
	struct timeval start##x, end##x; \
	double dur##x;

/** start timer with index x */
#define ___GRIP_START_TIMER(x) \
	gettimeofday(&start##x, NULL);

/** end timer with index i and print the passed time */
#define ___GRIP_END_TIMER_AND_PRINT(i,x,y,z) \
	gettimeofday(&end##i, NULL);	\
	dur##i = (end##i.tv_usec - start##i.tv_usec) / 1000.0;	\
	std::cout << x << "(" << z << "), " << y << ": " << dur##i << " ms" << std::endl;

#define ___GRIP_GET_TIMER_VALUE_AND_RESET(x) \
		gettimeofday(&end##x, NULL); \
		dur##x = (end##x.tv_usec - start##x.tv_usec) / 1000.0;	\
		start##x = end##x;

#else

#define ___GRIP_INITIALIZE_TIMER(x)
#define ___GRIP_START_TIMER(x)
#define ___GRIP_END_TIMER_AND_PRINT(i, x, y, z)

#endif





#endif /* TIMERMACROS_H_ */
