#!/usr/bin/awk
#this awk script is meant for generating the Types_Generators.h file, which holds all the relevant typed parts of the poproc code

#this is the important function for adding new types
function define_basic_stuff() {
	
	#pre- and suffices first
	type_suffix = "_t"
	sptr_suffix = "_sptr"
	enum_prefix = "enum_"
	dt_prefix = "dt_"
	
	#void has to be index 0
	primitive_types_base[0] = "void"
	primitive_types_type[0] = "void"type_suffix
	primitive_types_sptr[0] = "void"sptr_suffix
	#primitive_types_cuda[0] = primitive_types_base[0]"*"
	
	primitive_types_base[1] = "uint8_t"
	primitive_types_type[1] = "uint8"type_suffix
	primitive_types_sptr[1] = "uint8"sptr_suffix
	#primitive_types_cuda[1] = primitive_types_base[1]"*"
	
	primitive_types_base[2] = "int8_t"
	primitive_types_type[2] = "int8"type_suffix
	primitive_types_sptr[2] = "int8"sptr_suffix
	#primitive_types_cuda[2] = primitive_types_base[2]"*"
	
	primitive_types_base[3] = "uint16_t"
	primitive_types_type[3] = "uint16"type_suffix
	primitive_types_sptr[3] = "uint16"sptr_suffix
	#primitive_types_cuda[3] = primitive_types_base[3]"*"
	
	primitive_types_base[4] = "int16_t"
	primitive_types_type[4] = "int16"type_suffix
	primitive_types_sptr[4] = "int16"sptr_suffix
	#primitive_types_cuda[4] = primitive_types_base[4]"*"
	
	primitive_types_base[5] = "uint32_t"
	primitive_types_type[5] = "uint32"type_suffix
	primitive_types_sptr[5] = "uint32"sptr_suffix
	#primitive_types_cuda[5] = primitive_types_base[5]"*"
	
	primitive_types_base[6] = "int32_t"
	primitive_types_type[6] = "int32"type_suffix
	primitive_types_sptr[6] = "int32"sptr_suffix
	#primitive_types_cuda[6] = primitive_types_base[6]"*"
	
	primitive_types_base[7] = "uint64_t"
	primitive_types_type[7] = "uint64"type_suffix
	primitive_types_sptr[7] = "uint64"sptr_suffix
	#primitive_types_cuda[7] = primitive_types_base[7]"*"
	
	primitive_types_base[8] = "int64_t"
	primitive_types_type[8] = "int64"type_suffix
	primitive_types_sptr[8] = "int64"sptr_suffix
	#primitive_types_cuda[8] = primitive_types_base[8]"*"
	
	primitive_types_base[9] = "float"
	primitive_types_type[9] = "float"type_suffix
	primitive_types_sptr[9] = "float"sptr_suffix
	#primitive_types_cuda[9] = primitive_types_base[9]"*"
	
	primitive_types_base[10] = "double"
	primitive_types_type[10] = "double"type_suffix
	primitive_types_sptr[10] = "double"sptr_suffix
	#primitive_types_cuda[10] = primitive_types_base[10]"*"
	
	primitive_types_base[11] = "std::string"
	primitive_types_type[11] = "string"type_suffix
	primitive_types_sptr[11] = "string"sptr_suffix;
	
	
	#all dependent types
	dependent_types_base[0] = "UniversalImage<dt_float_t, 4>"
	dependent_types_type[0] = "UniversalImage_float_4"type_suffix
	dependent_types_sptr[0] = "UniversalImage_float_4"sptr_suffix
	#dependent_types_cuda[0] = "float*"
	
	dependent_types_base[1] = "UniversalImage<dt_uint8_t, 4>"
	dependent_types_type[1] = "UniversalImage_uint8_4"type_suffix
	dependent_types_sptr[1] = "UniversalImage_uint8_4"sptr_suffix
	#dependent_types_cuda[1] = "uint8_t*"
	
	dependent_types_base[2] = "UniversalImage<dt_float_t, 1>"
	dependent_types_type[2] = "UniversalImage_float_1"type_suffix
	dependent_types_sptr[2] = "UniversalImage_float_1"sptr_suffix
	#dependent_types_cuda[2] = "float*"
	
	
	
	#all xml types
    #primitive_types_xml[0] = "uint8"
    #primitive_types_xml[1] = "uint16"
    #primitive_types_xml[2] = "uint32"
    #primitive_types_xml[3] = "uint64"
    #primitive_types_xml[4] = "int8"
    #primitive_types_xml[5] = "int16"
    #primitive_types_xml[6] = "int32"
    #primitive_types_xml[7] = "int64"
    #primitive_types_xml[8] = "float"
    #primitive_types_xml[9] = "double"
	
	#dependent_types_xml[0] = "image_float_4"

	#generate array with all types for easier iterating
	for (i = 0; i < length(primitive_types_base) + length(dependent_types_base); i++) {
		if (i < length(primitive_types_base)) {
			all_types_base[i] = primitive_types_base[i];
			all_types_type[i] = primitive_types_type[i];
			all_types_sptr[i] = primitive_types_sptr[i];
		} else {
			all_types_base[i] = dependent_types_base[i - length(primitive_types_base)]
			all_types_type[i] = dependent_types_type[i - length(primitive_types_base)]
			all_types_sptr[i] = dependent_types_sptr[i - length(primitive_types_base)]
		}
	}
}


#typedefs for primitive types
function generate_typedefs_primitive() {
	print "#define ___GENERATE_TYPEDEFS_PRIMITIVE \\"
	for (i = 0; i < length(primitive_types_base); i++) {
		print "\ttypedef "primitive_types_base[i]" dt_"primitive_types_type[i]"; \\";
		print "\ttypedef std::tr1::shared_ptr<"dt_prefix primitive_types_type[i]"> dt_"primitive_types_sptr[i]"; \\";
	}
	print
}


#typedefs for dependent types
function generate_typedefs_dependent() {
	print "#define ___GENERATE_TYPEDEFS_DEPENDENT \\"
	for (i = 0; i < length(dependent_types_base); i++) {
		print "\ttypedef "dependent_types_base[i]" dt_"dependent_types_type[i]"; \\";
		print "\ttypedef std::tr1::shared_ptr<"dt_prefix dependent_types_type[i]"> dt_"dependent_types_sptr[i]"; \\";
	}
	print
}


#branching in getIdByType() function
function generate_getidbytype_branching() {
	print "#define ___GENERATE_GETIDBYTYPE_BRANCHING \\"
	print "\tif(false) { return -1; } \\"
	for (i = 0; i < length(all_types_base); i++) {
		if (i > 0) {
			print "\telse if (typeid(FTYPE) == typeid("dt_prefix all_types_type[i]")) { return " toupper(enum_prefix dt_prefix all_types_type[i])";} \\"
		}
		print "\telse if (typeid(FTYPE) == typeid("dt_prefix all_types_sptr[i]")) { return " toupper(enum_prefix dt_prefix all_types_sptr[i])";} \\"
	}
	print "else { return -1; }"
	print
}


#name assignment
function generate_name_assignment() {
	print "#define ___GENERATE_NAME_ASSIGNMENT \\"
	print "\tsm_typeNames[0] = \"untyped \"; \\"
	for (i = 0; i < length(all_types_base); i++) {
		if (i > 0) {
			print "\tsm_typeNames["toupper(enum_prefix dt_prefix all_types_type[i])"] = \"" dt_prefix all_types_type[i]"\"; \\"
		}
		print "\tsm_typeNames["toupper(enum_prefix dt_prefix all_types_sptr[i])"] = \"" dt_prefix all_types_sptr[i]"\"; \\"
	}
	print
}


#enum list
function generate_enumlist() {
	print "#define ___GENERATE_ENUMLIST \\"
	print "\tenum dt_typeIds { \\"
	for (i = 0; i < length(all_types_base); i++) {
		print "\t\t"toupper(enum_prefix dt_prefix all_types_type[i]" = "(i*2))", \\"
		print "\t\t"toupper(enum_prefix dt_prefix all_types_sptr[i]" = "(i*2+1))", \\"
	}
	print "\t} \\"
	print
	
    print "#define ___DT_TYPEID_MIN 0"
    print "#define ___DT_TYPEID_MAX "(length(all_types_base)-1)*2+1
    	
	print
}


#UniversalContainer: map registry for container
function generate_map_registry() {
	print "#define ___GENERATE_MAP_REGISTRY \\"
	for (i = 0; i < length(all_types_base); i++) {
		if (i > 0) {
			print "\tMapRegistry< "dt_prefix all_types_type[i]" >::type __m_elementMap_"dt_prefix all_types_type[i]"; \\"
		}
		print "\tMapRegistry< "dt_prefix all_types_sptr[i]" >::type __m_elementMap_"dt_prefix all_types_sptr[i]"; \\"
	}
	print
}


#UniversalContainer: getmap function for container
function generate_getmap_function() {
	print "#define ___GENERATE_GETMAP_FUNCTION \\"
	for (i = 0; i < length(all_types_base); i++) {
		if (i > 0) {
			print "\ttemplate<> __inline__ MapRegistry< "dt_prefix all_types_type[i]" >::type& CLASSNAME::getMap< "dt_prefix all_types_type[i]" >() { ; return __m_elementMap_"dt_prefix all_types_type[i]"; }\\"
		}
		print "\ttemplate<> __inline__ MapRegistry< "dt_prefix all_types_sptr[i]" >::type& CLASSNAME::getMap< "dt_prefix all_types_sptr[i]" >() { ; return __m_elementMap_"dt_prefix all_types_sptr[i]"; }\\"
	}
	print
}


#cudaFree branching for node_cleanup_cuda
#function generate_cudafree_branching() {
#	print "#define ___GENERATE_FREE_DEVICE_DATA_CUDA \\"
#	print "\tswitch(it->second.typeId) { \\"
#	
#	for (i = 0; i < length(primitive_types_type); i++) {
#		print "\t\tcase grip::" toupper(enum_prefix dt_prefix primitive_types_type[i]) ": { \\"
#		print "\t\t\t"primitive_types_cuda[i] " thePtr = (" primitive_types_cuda[i] ") it->second.devicePtr; \\"
#		print "\t\t\tcudaFree(thePtr); \\"
#		
#		print "\t\t\tstd::cout << \"Freed device data: \" << it->first << \" ("primitive_types_cuda[i]")\" << std::endl; \\"
#		
#		print "\t\t\tbreak; \\"
#		print "\t\t} \\"
#	}
#	
#	for (i = 0; i < length(primitive_types_sptr); i++) {
#		print "\t\tcase grip::" toupper(enum_prefix dt_prefix primitive_types_sptr[i]) ": { \\"
#		print "\t\t\t"primitive_types_cuda[i] " thePtr = (" primitive_types_cuda[i] ") it->second.devicePtr; \\"
#		print "\t\t\tcudaFree(thePtr); \\"
#		
#		print "\t\t\tstd::cout << \"Freed device data: \" << it->first << \" ("primitive_types_cuda[i]")\" << std::endl; \\"
#		
#		print "\t\t\tbreak; \\"
#		print "\t\t} \\"
#	}
#	
#	for (i = 0; i < length(dependent_types_sptr); i++) {
#		print "\t\tcase grip::" toupper(enum_prefix dt_prefix dependent_types_sptr[i]) ": { \\"
#		print "\t\t\t"dependent_types_cuda[i] " thePtr = (" dependent_types_cuda[i] ") it->second.devicePtr; \\"
#		print "\t\t\tcudaFree(thePtr); \\"
#		
#		print "\t\t\tstd::cout << \"Freed device data: \" << it->first << \" ("dependent_types_cuda[i]")\" << std::endl; \\"
#		
#		print "\t\t\tbreak; \\"
#		print "\t\t} \\"
#	}
#	
#	print "\t\tdefault: { break; } \\"
#	
#	print "\t} \\"
#	
#	print "\tit->second.devicePtr = 0;"
#	
#	print
#}


#UniversalDataElement: makenullelement function for all sptr types
function generate_makenullelement() {
	print "#define ___GENERATE_MAKENULLELEMENT \\"
	for (i = 0; i < length(all_types_base); i++) {
		print "\ttemplate<> INLINE void CLASSNAME< "dt_prefix all_types_sptr[i]" >::makeNullElement() {\\"
		print "\t\t"dt_prefix all_types_sptr[i]" thePtr = "dt_prefix all_types_sptr[i]"();\\"
		print "\t\tset(thePtr, 0, 0);\\"
		print "\t} \\"
	}
	print
}

#UniversalDataElement: isnullelement function for all sptr types
function generate_isnullelement() {
	print "#define ___GENERATE_ISNULLELEMENT \\"
	for (i = 0; i < length(all_types_base); i++) {
		print "\ttemplate<> INLINE bool CLASSNAME< "dt_prefix all_types_sptr[i]" >::isNullElement() {\\"
		print "\t\t return (__m_data == "dt_prefix all_types_sptr[i]"() && __m_size == 0 && __m_typeId == 0); \\"
		print "}\\"
	}
	print
}


BEGIN {
	print "/** THIS FILE HAS BEEN GENERATED BY generic_codegen.awk ON " strftime( "%Y-%m-%d, %H:%M", systime() ) " */"
	
	print
	
	print "#include <stdint.h>"
	print "#include <tr1/memory>"
	print "#include <string>"
	#print "#include <CImg.h>"
	#print "using namespace cimg_library;"	
	
	print
	
	define_basic_stuff();
	generate_typedefs_primitive();
	generate_typedefs_dependent();
	generate_getidbytype_branching();
	generate_name_assignment();
	generate_enumlist();
	generate_map_registry();
	generate_getmap_function();	
	#generate_cudafree_branching();
	generate_makenullelement();
	generate_isnullelement();

}