/* CUDA Node template for use with the PoProcK image processing library */

#include <iostream>
#include <string>

#include <Graph/NodeInterface.h>
#include <Graph/NodeHelper.h>
#include <Data/TempBufferRepository.h>

#include "parameters.h"

/** has to be renamed accordingly */

using namespace std;


/** this is the main kernel run function. Arguments may be changed according to what the filter does, e.g. to pass image pointers etc. */
extern void run_cuda(Parameters& p_parm);

extern "C" bool can_be_deactivated() {
	return false;	
}

extern "C" void run_node(const string& p_nodeName, grip::GraphWrapper& p_gw, grip::UniversalContainer& p_uniCon, grip::TempBufferRepositoryDirectory& p_tbRepoDir) {
	/** just output information ;) */
//	cout << "RUN_NODE (node_ifloat4_to_iuchar4_cuda) CALLED! (" << p_nodeName << ")" << endl;
	
	grip::NodeHelper nh(p_nodeName, p_gw, p_uniCon);

	string colorType, colorName, targetType, targetName;
	nh.getIOTypeAndIdentifier("input_float", colorType, colorName);
	nh.getIOTypeAndIdentifier("output_uchar", targetType, targetName);

//	if (minuendType != subtrahendType || minuendType != targetType) {
//		nh.errorInequalTypes();
//	}

	if (colorType == "image_float_4" && targetType == "image_uint8_4") {

		Parameters parm;

		GRIP_GET_IMAGE_AND_SET_PARAMETERS_FOR_CUDA(grip::dt_UniversalImage_float_4_sptr, float*, colorImage, colorName, parm.colorImage);

		parm.resx = colorImage->getResX();
		parm.resy = colorImage->getResY();

		GRIP_GET_STATIC_OR_DYNAMIC_ATTRIBUTE("alpha", parm.alpha, grip::dt_float_t);

		GRIP_CREATE_TARGET_IMAGE_AND_SET_PARAMETERS_FOR_CUDA(grip::dt_UniversalImage_uint8_4, uchar*, parm.resx, parm.resy, targetImage, targetName, parm.targetImage);

		run_cuda(parm);

		p_uniCon.setObject<grip::dt_UniversalImage_uint8_4_sptr>(targetName, targetImage, 1);

		GRIP_UPDATE_DIRTY_FLAG_AND_DEVICE_PTR(colorName, parm.colorImage, float*);
		GRIP_UPDATE_DIRTY_FLAG_AND_DEVICE_PTR(targetName, parm.targetImage, uchar*);

	} else {
		nh.errorUnsupportedFormat();
	}

}
