#ifndef __CAMERA_H__
#define __CAMERA_H__


#include <SixAxis.h>
#include <optixu/optixpp_namespace.h>
#include <optixu/optixu_math_namespace.h>
#include <optixu/optixu_matrix_namespace.h>

class Camera {

  private:
    optix::float3 __m_eye;
    optix::float3 __m_up;
    optix::float3 __m_look_at;
    optix::float3 __m_direction;
    optix::float3 __m_local_x;

    float __m_hfov;
    float __m_aspect_ratio;

    bool __m_isInitialized;


  public:

    Camera();


    Camera ( optix::float3 p_eye, optix::float3 p_up, optix::float3 p_look_at, float p_hfov, optix::float2 p_res );


//	void initialize(optix::float3 p_eye, optix::float3 p_up, optix::float3 p_look_at, float p_hfov, optix::float2 p_res);
    void initialize ( float *p_eye_x, float *p_up_x, float *p_look_at_x, float p_hfov, float *p_res_x );


    void setEye ( optix::float3 p_eye );


    void setUp ( optix::float3 p_up );


    void setLookAt ( optix::float3 p_look_at );


    void setEye( float p_x, float p_y, float p_z);
    void setUp( float p_x, float p_y, float p_z);
    void setLookAt( float p_x, float p_y, float p_z);


    void setHfov ( float p_hfov );



    optix::float3 getEye();
    optix::float3 getUp();
    optix::float3 getLookAt();
    optix::float3 getDirection();
    float getHfov();
    float getAspectRatio();



    void transform ( float p_theta, float p_phi, float p_roll, optix::float3 p_move, float p_time );


    void transform ( SixAxis *p_sixAxis, float p_time );




    ~Camera();



};

#endif