#ifndef __CONTEXTWRAPPER_H__
#define __CONTEXTWRAPPER_H__

#include <vector>
#include <iostream>

#include <optixu/optixpp_namespace.h>
#include <common_structs.h>

#include <Camera.h>

#include <helpers.h>

class ContextWrapper {

  private:

    optix::Context __m_context;
    unsigned int __m_maxDepth;
    unsigned int __m_renderWidth;
    unsigned int __m_renderHeight;
    bool __m_isInitialized;



  public:

    ContextWrapper();

    ContextWrapper ( unsigned int p_renderWidth, unsigned int p_renderHeight );


    ContextWrapper ( optix::Context p_context, unsigned int p_renderWidth, unsigned int p_renderHeight );


    void initialize ( unsigned int p_renderWidth, unsigned int p_renderHeight );


    void initialize ( optix::Context p_context, unsigned int p_renderWidth, unsigned int p_renderHeight );


    ~ContextWrapper();


    void initializeContext() ;


    void createOptixPrograms();

    void setMaxDepth ( unsigned int p_maxDepth );


    optix::Context &getContext();


    void setDevices_consecutive ( int p_firstDev, int p_numDevs );


    void setBuffer ( const std::string &p_name, optix::Buffer p_buffer );




};


#endif