/*
 * Distribution1D.h
 *
 *  Created on: 23.10.2012
 *      Author: troth
 */


#ifndef __DISTRIBUTION2D_H__
#define __DISTRIBUTION2D_H__

#include <optixu/optixpp_namespace.h>
#include <optixu/optixu_math_namespace.h>
#include <optixu/optixu_matrix_namespace.h>
#include <optix_cuda_interop.h>
#include <vector>

#include <string.h>
#include <iostream>



class Distribution2D {

  private:
    optix::Context __m_context;

    optix::Buffer __m_func_buffer, __m_cdf_buffer, __m_funcInt_buffer;
    optix::Buffer __m_margFunc_buffer, __m_margCdf_buffer;
    float __m_margFuncInt;

    float *__m_func, *__m_cdf, *__m_funcInt;
    float *__m_margFunc, *__m_margCdf;

    unsigned int __m_nu;
    unsigned int __m_nv;
    //	std::vector<Distribution1D*> __m_pConditionalV;
    //	Distribution1D *__m_pMarginal;


    bool buffersMapped();

    void computeIntegralForAllXi ( unsigned int p_index );

    void transformIntegralIntoCDF ( unsigned int p_index );

    void mapBuffers();

    void unmapBuffers();

  public:
    Distribution2D ( optix::Context p_context, const float *p_func, unsigned int p_nu, unsigned int p_nv );


};

#endif

