/*
 * constants.h
 *
 *  Created on: Aug 16, 2011
 *      Author: troth22s
 */

#ifndef CONSTANTS_H_
#define CONSTANTS_H_

#define TWOPI			6.28318531f
#define FOURPI			12.5663706f
#define INV_PI  		0.318309886f
#define INV_TWOPI 		0.159154943f
#define INV_FOURPI 		0.079577472f
#define INV_EIGHTPI		0.039788736f


/**
 * All sky parameters are to be understood with respect to the specific area
 * This means that the sky values describe an illumination of the defined values
 * over the whole unit sphere, i.e. an area of 4 * pi
 */



#define MIN_SKY_R 10.f
#define MIN_SKY_G 10.f
#define MIN_SKY_B 10.f
#define MIN_SKY_RGB optix::make_float3(MIN_SKY_R, MIN_SKY_G, MIN_SKY_B)

#define MAX_SKY_R 1000.f
#define MAX_SKY_G 1000.f
#define MAX_SKY_B 1000.f
#define MAX_SKY_RGB optix::make_float3(MAX_SKY_R, MAX_SKY_G, MAX_SKY_B)


#define MIN_SUN_R 3000.f
#define MIN_SUN_G 1000.f
#define MIN_SUN_B 1000.f
#define MIN_SUN_RGB optix::make_float3(MIN_SUN_R, MIN_SUN_G, MIN_SUN_B)

#define MAX_SUN_R 100000.f
#define MAX_SUN_G 100000.f
#define MAX_SUN_B 100000.f
#define MAX_SUN_RGB optix::make_float3(MAX_SUN_R, MAX_SUN_G, MAX_SUN_B)

#define SUN_AXIS optix::normalize(optix::make_float3(0.f, 0.f, 1.f))
#define SUN_STARTPOSITION optix::normalize(optix::make_float3(1.f, 1.f, 1.f))
#define SUN_COSDIAMETER 0.9999847695	// cosine of subtended solid angle

/* these exponents influence the computation of sun color */
#define SUN_EXPONENT_R	0.6f
#define SUN_EXPONENT_G	1.0f
#define SUN_EXPONENT_B	1.3f

#endif /* CONSTANTS_H_ */
