
// we need all the camera data here
#define __DECLARE_OPTIX_VARS_CAMERA__ \
    rtDeclareVariable(optix::float3, eye, ,); \
    rtDeclareVariable(optix::float3, U, ,); \
    rtDeclareVariable(optix::float3, V, ,); \
    rtDeclareVariable(optix::float3, W, ,); \
    rtDeclareVariable(float, focalDist, ,); \
    rtDeclareVariable(float, apertureRadius, ,); \
    rtDeclareVariable(unsigned int, maxDepth, ,); \
    rtDeclareVariable(uint2, launch_dim, rtLaunchDim,);  \
    rtDeclareVariable(uint2, launch_index, rtLaunchIndex,); \
    rtDeclareVariable(float, nearplane_dist, ,); \
    rtDeclareVariable(float, farplane_dist, ,); \
    rtDeclareVariable(uint, projectionType, ,); \
    rtDeclareVariable(uint, out_direct, ,); \
    rtDeclareVariable(uint, out_indirect, ,); \
    rtDeclareVariable(uint, out_gbuffer, ,); \
    rtDeclareVariable(uint, out_texture, ,); \
    rtDeclareVariable(uint, out_raydir, ,);


#define __DECLARE_OPTIX_VARS_GEOMETRY_INFO__ \
    rtDeclareVariable(rtObject, top_object, ,); \
    rtDeclareVariable(rtObject, light_group, ,); \
    rtDeclareVariable(float, scene_epsilon, ,);

#define __DECLARE_OPTIX_VARS_FRAMEINFO__ \
    rtDeclareVariable(unsigned int, numPreviousFrames, ,); \
    rtDeclareVariable(unsigned int, frame, ,); \
    rtDeclareVariable(unsigned int, processId, ,); \
    rtDeclareVariable(unsigned int, numProcesses, ,);

#define __DECLARE_OPTIX_VARS_SAMPLER_SETTINGS__ \
    rtDeclareVariable(unsigned int, useLdSampling_image, ,); \
    rtDeclareVariable(unsigned int, useLdSampling_lens, ,); \
    rtDeclareVariable(unsigned int, useLdSampling_environment, ,); \
    rtDeclareVariable(unsigned int, useLdSampling_sun, ,); \
    rtDeclareVariable(unsigned int, useLdSampling_integrator, ,); \
    rtDeclareVariable(float, lightProb_diffuse, ,); \
    rtDeclareVariable(float, lightProb_specular, ,);


#define __DECLARE_OPTIX_VARS_OUTPUT_BUFFERS__ \
    rtBuffer<optix::float4, 2> output_buffer_directLight; \
    rtBuffer<optix::float4, 2> output_buffer_indirectLight; \
    rtBuffer<optix::float4, 2> output_buffer_indirectLight_squared; \
    rtBuffer<optix::float4, 2> output_buffer_position; \
    rtBuffer<optix::float4, 2> output_buffer_texture; \
    rtBuffer<optix::float4, 2> output_buffer_depth_normal; \
    rtBuffer<optix::float4, 2> output_buffer_rayDirection; \
    rtBuffer<optix::float4, 2> output_buffer_rayDirection_squared;

#define __DECLARE_OPTIX_VARS_RAY_TYPES__ \
    rtDeclareVariable(unsigned int, occlusion_ray_type , , ); \
    rtDeclareVariable(unsigned int, pt_ray_type , , ); \
    rtDeclareVariable(unsigned int, shadow_ray_type, ,);

#define __DECLARE_OPTIX_VARS_SOBOL_BUFFERS__ \
    rtBuffer<optix::uint, 1> sobol_directions; \
    rtBuffer<optix::uint, 2> shuffle_image;

#define __DECLARE_OPTIX_VARS_RAY_DATA__ \
    rtDeclareVariable(optix::Ray, ray, rtCurrentRay, ); \
    rtDeclareVariable(PerRayData_pt, prd_pt, rtPayload, ); \
    rtDeclareVariable(PerRayData_occlusion, prd_occlusion, rtPayload, ); \
    rtDeclareVariable(PerRayData_shadow, prd_shadow, rtPayload, );


#define __DECLARE_OPTIX_VARS_LIGHT_DATA__ \
    rtDeclareVariable(float, flux, ,); \
    rtDeclareVariable(float, area, ,);



#define __DECLARE_OPTIX_VARS_ENVIRONMENT_INFO__ \
    rtDeclareVariable(float3, directionalLight_direction, ,); \
    rtDeclareVariable(float3, directionalLight_fluxRGB, ,); \
    rtDeclareVariable(float, sunScale, ,); \
    rtDeclareVariable(float, sunBrightness, ,); \
    rtDeclareVariable(float, skyBrightness, ,); \
    rtDeclareVariable(float, envRotPhi, ,); \
    rtDeclareVariable(unsigned int, envFlipYZ, ,); \
    rtTextureSampler<float4, 2> bg_map; \
    rtBuffer<float, 2> envMap_importance;

#define __DECLARE_OPTIX_VARS_LIGHT_BUFFERS__ \
    rtBuffer<LightSourceSphere> sphereLights; \
    rtBuffer<LightSourcePoint> pointLights;

#define __DECLARE_OPTIX_VARS_SHADING_INFO__ \
    rtDeclareVariable(float3, shading_normal, attribute shading_normal, ); \
    rtDeclareVariable(float3, geometric_normal, attribute geometric_normal, ); \
    rtDeclareVariable(float, t_hit, rtIntersectionDistance, ); \
    rtDeclareVariable(float3, texcoord, attribute texcoord, ); \
    rtDeclareVariable(float3, color, ,); \
    rtDeclareVariable(float, alpha, ,); \
    rtDeclareVariable(float, phong_exp, ,); \
    rtDeclareVariable(float3, kd, ,); \
    rtDeclareVariable(float3, ks, ,); \
    rtDeclareVariable(float3, tf, ,); \
    rtDeclareVariable(float, ni, ,);


#define __DECLARE_OPTIX_VARS_TEXTURES_DIFFUSE__ \
    rtTextureSampler<float4, 2> diffuse_map;

#define __DECLARE_OPTIX_VARS_TEXTURES_DISSOLVE__ \
    rtTextureSampler<float4, 2> dissolve_map;

#define __DECLARE_OPTIX_VARS_TEXTURES_SPECULAR__ \
    rtTextureSampler<float4, 2> specular_map;
	
#define __DECLARE_OPTIX_VARS_LIGHT_FIELD__ \
	rtBuffer<UserType_lightField, 2> output_buffer_lightField;
