#ifndef __SOBOL__CUDA__CU__
#define __SOBOL__CUDA__CU__

#define SOBOL_SKIP 64

#include <optix_declaration_macros.h>

#ifndef __OPTIX_VARS_CAMERA__
#define __OPTIX_VARS_CAMERA__
__DECLARE_OPTIX_VARS_CAMERA__
#endif

#ifndef __OPTIX_VARS_SOBOL_BUFFERS__
#define __OPTIX_VARS_SOBOL_BUFFERS__
__DECLARE_OPTIX_VARS_SOBOL_BUFFERS__
#endif

#ifndef __OPTIX_VARS_RAY_DATA__
#define __OPTIX_VARS_RAY_DATA__
__DECLARE_OPTIX_VARS_RAY_DATA__
#endif

__device__ float Sobol ( unsigned int dimension, unsigned int index, unsigned int &p_rngSeed, unsigned int p_uniform = 0 ) {
    unsigned int result = 0;
    unsigned int i = index + SOBOL_SKIP;

    for ( unsigned int j = 0; i; i >>= 1, j++ ) {
        if ( i & 1u )
        { result ^= sobol_directions[32 * dimension + j]; }
    }

    unsigned int pixelIndex = launch_index.y * launch_dim.x + launch_index.x;
    unsigned int rndSeed = hash ( pixelIndex );
    float r = result * ( 1.0f / ( float ) 0xFFFFFFFF );
    float shift;
    unsigned int u1 = rnd ( rndSeed ) * RAND_MAX;

    if ( dimension & 1 )
    { shift = ( u1 >> 16 ) / ( ( float ) 0xFFFF ); }

    else
    { shift = ( u1 & 0xFFFF ) / ( ( float ) 0xFFFF ); }

    return r + ( 1 - p_uniform ) * ( shift - floorf ( r + shift ) );
    //return result * (1.0f/(float)0xFFFFFFFF);
}
#endif