#pragma once


typedef glm::ivec2 point;
typedef glm::mat2 matrix;

namespace PSHHelper {


	uint64_t commonFactor(uint64_t p_a, uint64_t p_b) {

		for (uint64_t i = 2; i <= (uint64_t)fminf(p_a, p_b); ++i) {

			if (p_a % i == 0 && p_b % i == 0) {
				
				return i;
			}

		}
		
		return 1;

	}



	void compute3dIndex(uint64_t* p_3dIndex, uint64_t p_index, uint64_t p_dimSize[3]) {		
		p_3dIndex[2] = p_index / (p_dimSize[0] * p_dimSize[1]);
		p_index %= p_dimSize[0] * p_dimSize[1];
		p_3dIndex[1] = p_index / p_dimSize[0];
		p_index %= p_dimSize[0];
		p_3dIndex[0] = p_index;
	}



	int computeLinearIndex(uint64_t p_index[3], uint64_t p_dimSize[3]) {
		return p_index[2] * (p_dimSize[0] * p_dimSize[1]) + p_index[1] * p_dimSize[0] + p_index[0];
	}



	void printNDim(uint64_t p_size, uint64_t* p_data, uint64_t p_numDimensions, uint64_t* p_dimLimits) {

		for (uint64_t i = 0; i < p_size; ++i) {
			
			// if (isValid(i)) {
				std::cout << p_data[i];
			// } else {
				// std::cout << "-";
			// }

			std::cout << "\t";
			
			for (uint64_t j = 1; j < p_numDimensions; ++j) {

				if ((i + 1) % p_dimLimits[j] == 0) {
						std::cout << std::endl;
				}

			}

		}

		std::cout << std::endl;

	}



#ifdef DEBUG
	bool debug = true;
#else
	bool debug = false;
#endif

#define PRINT_DEBUG(X) \
	if (PSHHelper::debug) { \
		std::cout << X; \
	}

	


};