#include <stdlib.h>
#include <math.h>
#include <iostream>
#include <glm/glm.hpp>
#include <unistd.h>
#include <vector>
#include <string.h>


#include <pshHelper.h>
#include <HashTable.h>



matrix M0(1, 0, 0, 1);
matrix M1(1, 0, 0, 1);




int main(int argc, char** argv) {
	//initialize rand()
	time_t rndSeed = time(NULL);
	srand(rndSeed);

	if (argc < 3) {
		std::cerr << "Missing parameters <size1> <size2> <size...> <density>" << std::endl;
		exit(1);
	}
	
	uint64_t numDimensions = 3;
	uint64_t* dimSize = new uint64_t[numDimensions];
	
	for (int i = 0; i < numDimensions; ++i) {
		dimSize[i] = atoi(argv[i+1]);
		std::cout << "dimSize[" << i << "]: " << dimSize[i] << std::endl;
	}
	
	float density = atof(argv[argc - 1]);
	std::cout << "Data density: " << density << std::endl;

	//initialize data
	Data data(numDimensions, dimSize);
	data.erase();
	data.initialize(density);

	// data.printData();
	// std::cout << std::endl;
	// data.printValid();
	// std::cout << std::endl;


	HashTable hashTab(&data);

}