#pragma once


typedef glm::ivec2 point;
typedef glm::mat2 matrix;

namespace PSHHelper {
	int commonFactor(int p_a, int p_b) {

		for (int i = 2; i <= (int)fminf(p_a, p_b); ++i) {

			if (p_a % i == 0 && p_b % i == 0) {
				
				return i;
			}

		}
		
		return 1;

	}



	void computeNDimensionalIndex(int* p_nDimIndex, int p_index, int p_numDimensions, int* p_dimSize) {		
		int dimSizesAccum[p_numDimensions];
		int curDimSize = 1;
		for (int i = 0; i < p_numDimensions; ++i) {
			dimSizesAccum[i] = curDimSize;
			curDimSize *= p_dimSize[i];
		}

		int curIndex = p_index;
		for (int i = p_numDimensions - 1; i >= 0; --i) {
			p_nDimIndex[i] = curIndex / dimSizesAccum[i];
			curIndex %= dimSizesAccum[i];
			// std::cout << "ndIndex[" << (__m_numDimensions - 1 - i) << "]: " << ndIndex[__m_numDimensions - 1 - i] << "; ";
		}

		// std::cout << std::endl;
	}



	int computeLinearIndex(int *p_index, int p_numDimensions, int* p_dimSize) {
			
		// for (int i = __m_dimensions - 1; i >= 0; --i) {
		int linearIndex = 0;

		for (int i = p_numDimensions - 1; i >= 0; --i) {
			int curDimSizeAccum = 1;

			for (int j = 0; j < i; ++j) {
				curDimSizeAccum *= p_dimSize[j];
			}

			linearIndex += p_index[i] * curDimSizeAccum;

		}
		
		return linearIndex;

	}




	void printNDim(int p_size, int* p_data, int p_numDimensions, int* p_dimLimits) {

		for (int i = 0; i < p_size; ++i) {
			
			// if (isValid(i)) {
				std::cout << p_data[i];
			// } else {
				// std::cout << "-";
			// }

			std::cout << "\t";
			
			for (int j = 1; j < p_numDimensions; ++j) {

				if ((i + 1) % p_dimLimits[j] == 0) {
						std::cout << std::endl;
				}

			}

		}

		std::cout << std::endl;

	}

#ifdef DEBUG
	bool debug = true;
#else
	bool debug = false;
#endif

#define PRINT_DEBUG(X) \
	if (PSHHelper::debug) { \
		std::cout << X; \
	}

	


};