#include <PrimitiveCreators.h>

#include <helpers.h>

optix::Geometry createSphere ( optix::Context p_context, float p_x, float p_y, float p_z, float p_rad ) {
    optix::Geometry sphere = p_context->createGeometry();
    sphere->setPrimitiveCount ( 1u );
    sphere->setBoundingBoxProgram ( p_context->createProgramFromPTXFile ( generatePtxPath ( "sphere.cu" ), "sphere_bounds" ) );
    sphere->setIntersectionProgram ( p_context->createProgramFromPTXFile ( generatePtxPath ( "sphere.cu" ), "sphere_intersect" ) );
    sphere["sphere"]->setFloat ( p_x, p_y, p_z, p_rad );
    return sphere;
}
//
//
//optix::Geometry createPlane(optix::Context p_context, optix::float3 p_normal, float p_distance) {
//	optix::Geometry plane = p_context->createGeometry();
//	plane->setPrimitiveCount(1u);
//	plane->setBoundingBoxProgram(p_context->createProgramFromPTXFile(generatePtxPath("plane.cu"), "plane_bounds"));
//	plane->setIntersectionProgram(p_context->createProgramFromPTXFile(generatePtxPath("plane.cu"), "plane_intersect"));
//	plane["planeNormal"]->setFloat(p_normal);
//	plane["planeDistance"]->setFloat(p_distance);
//	return plane;
//}
//
//
//
optix::Geometry createBox ( optix::Context p_context, float p_x0, float p_y0, float p_z0, float p_x1, float p_y1, float p_z1 ) {
    optix::Geometry box = p_context->createGeometry();
    box->setPrimitiveCount ( 1u );
    box->setBoundingBoxProgram ( p_context->createProgramFromPTXFile ( generatePtxPath ( "box.cu" ), "box_bounds" ) );
    box->setIntersectionProgram ( p_context->createProgramFromPTXFile ( generatePtxPath ( "box.cu" ), "box_intersect" ) );
    box["boxmin"]->setFloat ( p_x0, p_y0, p_z0 );
    box["boxmax"]->setFloat ( p_x1, p_y1, p_z1 );
    return box;
}

