#include <RenderParameters.h>


std::vector<int32_t> __m_intParameters;
std::vector<float> __m_floatParameters;

std::vector<string> __m_intParameterNamesOptix;
std::vector<string> __m_floatParameterNamesOptix;
std::vector<string> __m_intParameterNamesGrip;
std::vector<string> __m_floatParameterNamesGrip;




RenderParameters::RenderParameters()
    : __m_intParameters ( ( int ) ENUM_NUM_RENDERPARAMETERS_INT ),
      __m_intParameterNamesGrip ( ( int ) ENUM_NUM_RENDERPARAMETERS_INT ),
      __m_intParameterNamesOptix ( ( int ) ENUM_NUM_RENDERPARAMETERS_INT ),
      __m_floatParameters ( ( int ) ENUM_NUM_RENDERPARAMETERS_FLOAT ),
      __m_floatParameterNamesGrip ( ( int ) ENUM_NUM_RENDERPARAMETERS_FLOAT ),
      __m_floatParameterNamesOptix ( ( int ) ENUM_NUM_RENDERPARAMETERS_FLOAT ) {
    // Empty parameter names mean that parameters are not available on the according side, which means that either they do not come from grip, but elsewhere or they are not made available on the device
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_MIN_DEPTH] = "minRecursionDepth";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_MIN_DEPTH] = "minDepth";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_MAX_DEPTH] = "maxRecursionDepth";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_MAX_DEPTH] = "maxDepth";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_RES_X] = "";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_RES_Y] = "";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_RES_X] = "";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_RES_Y] = "";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_FIRST_GPU] = "";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_FIRST_GPU] = "";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_NUM_GPUS] = "";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_NUM_GPUS] = "";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_MAX_SOBOL_DEPTH] = "";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_MAX_SOBOL_DEPTH] = "";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_USE_LD_SAMPLING_IMAGE] = "use_ld_sampling_image";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_USE_LD_SAMPLING_IMAGE] = "useLdSampling_image";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_USE_LD_SAMPLING_LENS] = "use_ld_sampling_lens";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_USE_LD_SAMPLING_LENS] = "useLdSampling_lens";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_USE_LD_SAMPLING_SUN] = "use_ld_sampling_sun";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_USE_LD_SAMPLING_SUN] = "useLdSampling_sun";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_USE_LD_SAMPLING_ENVIRONMENT] = "use_ld_sampling_environment";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_USE_LD_SAMPLING_ENVIRONMENT] = "useLdSampling_environment";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_USE_LD_SAMPLING_INTEGRATOR] = "use_ld_sampling_integrator";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_USE_LD_SAMPLING_INTEGRATOR] = "useLdSampling_integrator";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_SAMPLES_PER_LAUNCH] = "samplesPerLaunch";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_SAMPLES_PER_LAUNCH] = "";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_PROJECTION_TYPE] = "projectionType";
    __m_intParameterNamesOptix[ENUM_RENDERPARAMETER_PROJECTION_TYPE] = "projectionType";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_OUT_DIRECT] = "out_direct";
    __m_intParameterNamesOptix [ENUM_RENDERPARAMETER_OUT_DIRECT] = "out_direct";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_OUT_INDIRECT] = "out_indirect";
    __m_intParameterNamesOptix [ENUM_RENDERPARAMETER_OUT_INDIRECT] = "out_indirect";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_OUT_GBUFFER] = "out_gbuffer";
    __m_intParameterNamesOptix [ENUM_RENDERPARAMETER_OUT_GBUFFER] = "out_gbuffer";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_OUT_TEXTURE] = "out_texture";
    __m_intParameterNamesOptix [ENUM_RENDERPARAMETER_OUT_TEXTURE] = "out_texture";
    __m_intParameterNamesGrip [ENUM_RENDERPARAMETER_OUT_RAYDIR] = "out_raydir";
    __m_intParameterNamesOptix [ENUM_RENDERPARAMETER_OUT_RAYDIR] = "out_raydir";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_SCENE_EPSILON] = "sceneEpsilon";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_SCENE_EPSILON] = "scene_epsilon";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_SKY_BRIGHTNESS] = "sky_brightness";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_SKY_BRIGHTNESS] = "skyBrightness";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_APERTURE_RADIUS] = "cam_apertureRad";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_APERTURE_RADIUS] = "apertureRadius";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_ENV_ROT_PHI] = "envRot_phi";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_ENV_ROT_PHI] = "envRotPhi";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_ENV_GAMMA] = "";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_ENV_GAMMA] = "";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_LIGHT_PROB_DIFFUSE] = "lightProb_diffuse";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_LIGHT_PROB_DIFFUSE] = "lightProb_diffuse";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_LIGHT_PROB_SPECULAR] = "lightProb_specular";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_LIGHT_PROB_SPECULAR] = "lightProb_specular";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_SUN_AXIS_PHI] = "sun_axis_phi";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_SUN_AXIS_PHI] = "";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_SUN_AXIS_THETA] = "sun_axis_theta";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_SUN_AXIS_THETA] = "";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_SUN_BRIGHTNESS] = "sun_brightness";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_SUN_BRIGHTNESS] = "sunBrightness";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_SUN_SCALE] = "sun_scale";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_SUN_SCALE] = "sunScale";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_SUN_SCALE] = "sun_scale";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_SUN_SCALE] = "sunScale";
    __m_floatParameterNamesGrip [ENUM_RENDERPARAMETER_HFOV] = "hfov";
    __m_floatParameterNamesOptix[ENUM_RENDERPARAMETER_HFOV] = "";
}


RenderParameters::~RenderParameters() {
}


void RenderParameters::setParameterInt ( enum_parameterNames_int p_parameterName, float p_parameterValue ) {
    __m_intParameters[p_parameterName] = p_parameterValue;
}


void RenderParameters::setParameterFloat ( enum_parameterNames_float p_parameterName, float p_parameterValue ) {
    __m_floatParameters[p_parameterName] = p_parameterValue;
}


int RenderParameters::getParameterInt ( enum_parameterNames_int p_parameterName ) {
    return __m_intParameters[p_parameterName];
}


float RenderParameters::getParameterFloat ( enum_parameterNames_float p_parameterName ) {
    return __m_floatParameters[p_parameterName];
}


std::string &RenderParameters::getParameterNameGrip ( enum_parameterNames_int p_parameterName ) {
    return __m_intParameterNamesGrip[p_parameterName];
}


std::string &RenderParameters::getParameterNameGrip ( enum_parameterNames_float p_parameterName ) {
    return __m_floatParameterNamesGrip[p_parameterName];
}

std::string &RenderParameters::getParameterNameOptix ( enum_parameterNames_int p_parameterName ) {
    return __m_intParameterNamesOptix[p_parameterName];
}


std::string &RenderParameters::getParameterNameOptix ( enum_parameterNames_float p_parameterName ) {
    return __m_floatParameterNamesOptix[p_parameterName];
}


