/*
 * light_shader.cu
 *
 *  Created on: Aug 5, 2011
 *      Author: troth22s
 */


#include <optix.h>
#include <optixu/optixu_math_namespace.h>

#include <common_structs.h>
#include <random.h>
#include <tr1/float.h>

#include <optix_declaration_macros.h>

#ifndef __OPTIX_VARS_SHADING_INFO__
#define __OPTIX_VARS_SHADING_INFO__
__DECLARE_OPTIX_VARS_SHADING_INFO__
#endif

#ifndef __OPTIX_VARS_RAY_DATA__
#define __OPTIX_VARS_RAY_DATA__
__DECLARE_OPTIX_VARS_RAY_DATA__
#endif

#ifndef __OPTIX_VARS_LIGHT_DATA__
#define __OPTIX_VARS_LIGHT_DATA__
__DECLARE_OPTIX_VARS_LIGHT_DATA__
#endif




RT_PROGRAM void light_shader_pt() {
    rtIgnoreIntersection();
    // float3 hit_point = ray.origin + t_hit * ray.direction;
    // if (prd_pt.done) {
    //     prd_pt.origin = hit_point;
    //     prd_pt.hitDist = t_hit;
    //     return;
    // }

    // float3 normalizedNormal = optix::normalize ( rtTransformNormal ( RT_OBJECT_TO_WORLD, shading_normal ) );

    // if ( optix::dot ( normalizedNormal, -ray.direction ) < 0 ) {
    //     normalizedNormal = -normalizedNormal;
    // }

    // if ( prd_pt.directIllumination ) {
    //     prd_pt.dotProduct = fmaxf ( 0.f, optix::dot ( -ray.direction, normalizedNormal ) );
    //     prd_pt.f = make_float3 ( 1.f );
    //     prd_pt.radiance = ( flux * color ) / ( area * M_PIf );
    //     prd_pt.texCol = color;
    //     prd_pt.pdf = 1.f;

    // } else {
    //     prd_pt.dotProduct = 0.f;
    //     prd_pt.pdf = 0.f;
    // }

    // prd_pt.hitDist = t_hit;
    // prd_pt.normal = normalizedNormal;
    // prd_pt.done = true; // light sources do not reflect anything, so we do not need to continue tracing the ray
}


rtDeclareVariable ( unsigned int, identifier, , );

// return the appropriate normal and color for the according light source. also makes cuboid light sources render correctly ;)
RT_PROGRAM void light_shader_shadow() {
    float3 normalizedNormal = optix::normalize(rtTransformNormal(RT_OBJECT_TO_WORLD, shading_normal));

    if (optix::dot(normalizedNormal, ray.direction) > 0) {
        normalizedNormal = -normalizedNormal;
    }

    prd_shadow.hitDist = t_hit;

    if (identifier == prd_shadow.queryIdentifier) {
        prd_shadow.emittance = fmaxf(optix::dot(-ray.direction, normalizedNormal), 0.0f);
        prd_shadow.occluded = false;
    } else {
        prd_shadow.emittance = 0.0f;
        prd_shadow.occluded = true;
    }
}


// this is called when any object is hit by an shadow ray which is not a light source
RT_PROGRAM void shadow_shader() {
//  optix::float3 dissolveCol = make_float3(tex2D(dissolve_map, texcoord.x, texcoord.y));
//  float avg = alpha * dissolveCol.x;
//  if (rnd(prd_shadow.seed) > avg && ni == 1.f) {
//      prd_shadow.throughput *= (1.f - tf);
//      rtIgnoreIntersection();
//  } else {
//      prd_shadow.occluded = true;
//      rtTerminateRay();
//  }
}
