/*
 * occlusion_shader.cu
 *
 *  Created on: Aug 5, 2011
 *      Author: troth22s
 */

#include <optix.h>
#include <optix_device.h>
#include <optixu/optixu_math_namespace.h>

#include <common_structs.h>
#include <random.h>
#include <tr1/float.h>

#include <optix_declaration_macros.h>

#ifndef __OPTIX_VARS_SHADING_INFO__
#define __OPTIX_VARS_SHADING_INFO__
__DECLARE_OPTIX_VARS_SHADING_INFO__
#endif

#ifndef __OPTIX_VARS_RAY_TYPES__
#define __OPTIX_VARS_RAY_TYPES__
__DECLARE_OPTIX_VARS_RAY_TYPES__
#endif

#ifndef __OPTIX_VARS_TEXTURES_DISSOLVE__
#define __OPTIX_VARS_TEXTURES_DISSOLVE__
__DECLARE_OPTIX_VARS_TEXTURES_DISSOLVE__
#endif

#ifndef __OPTIX_VARS_RAY_DATA__
#define __OPTIX_VARS_RAY_DATA__
__DECLARE_OPTIX_VARS_RAY_DATA__
#endif


RT_PROGRAM void alpha_occlusion_tester() {
    optix::float3 dissolveCol = make_float3 ( tex2D ( dissolve_map, texcoord.x, texcoord.y ) );
    float avg = alpha * dissolveCol.x;

    if ( rnd ( prd_occlusion.seed ) > avg && ni == 1.f ) {
        prd_occlusion.throughput *= tf;
        rtIgnoreIntersection();

    } else {
        prd_occlusion.occluded = true;
        rtTerminateRay();
    }
}

/* only used in non-alpha materials */
RT_PROGRAM void occlusion_shader() {
	prd_occlusion.occluded = true;
	rtTerminateRay();
}
