/*
 * background_shader.cu
 *
 *  Created on: May 10, 2011
 *      Author: troth22s
 */

#include <optix_world.h>
#include <common_structs.h>

#include <constants.h>

#include <helpers.h>

#include <optix_declaration_macros.h>

#ifndef __OPTIX_VARS_ENVIRONMENT_INFO__
#define __OPTIX_VARS_ENVIRONMENT_INFO__
__DECLARE_OPTIX_VARS_ENVIRONMENT_INFO__
#endif

#ifndef __OPTIX_VARS_RAY_TYPES__
#define __OPTIX_VARS_RAY_TYPES__
__DECLARE_OPTIX_VARS_RAY_TYPES__
#endif

#ifndef __OPTIX_VARS_RAY_DATA__
#define __OPTIX_VARS_RAY_DATA__
__DECLARE_OPTIX_VARS_RAY_DATA__
#endif



RT_PROGRAM void background_shader() {
    if ( prd_pt.directIllumination ) {
        //      float phi = atan2f(ray.direction.x, ray.direction.z);
        float3 envDir = ray.direction;

        possiblyFlipYZ(envDir, envFlipYZ);

        float phi = atan2f ( envDir.y, ray.direction.x ) + envRotPhi;
        //      float theta = M_PIf * 0.5f - acosf(ray.direction.y);
        float theta = acosf ( envDir.z );
        float u = ( phi + M_PIf ) * INV_TWOPI;
        //      float u = phi * INV_TWOPI;
        //      float v = 0.5f * (1.0f + sinf(theta));
        float v = theta * INV_PI;
        float cosAngle = optix::dot ( ray.direction, directionalLight_direction );
        float cosSunScale = cosf ( sunScale );

        if ( cosAngle > cosSunScale ) {
            prd_pt.radiance = directionalLight_fluxRGB;
            prd_pt.texCol = make_float3 ( 1.f );

        } else {
            float3 bgCol = calculateSkyRGB ( directionalLight_direction, skyBrightness ) * make_float3 ( tex2D ( bg_map, u, v ) ); //fmaxf(MIN_SKY_RGB, MAX_SKY_RGB) * make_float3(tex2D(bg_map, u, v));// * (MAX_SKY_RGB * weightSun + MIN_SKY_RGB * (1.f - weightSun));
            //          float3 bgCol = calculateSkyRGB(directionalLight_direction, skyBrightness) * make_float3(envMap_importance[make_uint2(u * envWidth, v * envHeight)]);//fmaxf(MIN_SKY_RGB, MAX_SKY_RGB) * make_float3(tex2D(bg_map, u, v));// * (MAX_SKY_RGB * weightSun + MIN_SKY_RGB * (1.f - weightSun));
            //          bgCol = make_float3(68.f, 75.f, 132.f) /10.f;
            prd_pt.radiance = bgCol;
            prd_pt.texCol = make_float3 ( 1.f ); //make_float3(w1) + w2 * skyBrightness * make_float3(tex2D(bg_map, u, v));
        }
    }

    prd_pt.dotProduct = 1.f;
    prd_pt.pdf = 1.f;
    prd_pt.normal = -ray.direction;
    prd_pt.normal_geometric = -ray.direction;
    prd_pt.hitDist = 1.f;
    prd_pt.background = true;
    prd_pt.done = true;
}
