/*
 * box.cu
 *
 *  Created on: May 17, 2011
 *      Author: troth22s
 */

#include <optix_world.h>
#include <float.h>

rtDeclareVariable ( float3, planeNormal, , );
rtDeclareVariable ( float, planeDistance, , );

rtDeclareVariable ( float3, geometric_normal, attribute geometric_normal, );
rtDeclareVariable ( float3, shading_normal, attribute shading_normal, );
rtDeclareVariable ( optix::Ray, ray, rtCurrentRay, );

rtDeclareVariable ( float3, texU, attribute texU, );
rtDeclareVariable ( float3, texV, attribute texV, );


__device__ float3 plane_normal ( float t ) {
    return planeNormal;
}

RT_PROGRAM void plane_intersect ( int ) {
    shading_normal = geometric_normal = planeNormal;
    float t = - ( optix::dot ( shading_normal, ray.origin ) + planeDistance ) / ( optix::dot ( shading_normal, ray.direction ) );

    if ( rtPotentialIntersection ( t ) ) {
        texU = make_float3 ( 0.f );
        texV = make_float3 ( 0.f );
        rtReportIntersection ( 0 );
    }
}

RT_PROGRAM void plane_bounds ( int, float result[6] ) {
    optix::Aabb *aabb = ( optix::Aabb * ) result;
    aabb->set ( optix::make_float3 ( -FLT_MAX, -FLT_MAX, -FLT_MAX ), optix::make_float3 ( FLT_MAX, FLT_MAX, FLT_MAX ) );
}
