/*
 * PinholeCamera.cu
 *
 *  Created on: May 10, 2011
 *      Author: troth22s
 */

#include <optix_world.h>

#include <random.h>

#include <helpers.h>

#include <common_structs.h>

#include <constants.h>

// we need all the camera data here
rtDeclareVariable ( optix::float3, eye, , );
rtDeclareVariable ( optix::float3, U, , );
rtDeclareVariable ( optix::float3, V, , );
rtDeclareVariable ( optix::float3, W, , );
//rtDeclareVariable(optix::float3, bad_color, ,);
rtDeclareVariable ( float, scene_epsilon, , );



rtBuffer<float, 1> output_buffer_centerDepth;

//rtBuffer<optix::float4, 2> output_buffer_indirectLight;
//rtBuffer<optix::float4, 2> output_buffer_depth;
//rtBuffer<optix::float4, 2> output_buffer_texture;
//rtBuffer<unsigned int, 2> raynum_buffer;

rtDeclareVariable ( rtObject, top_object, , );
rtDeclareVariable ( unsigned int, occlusion_ray_type , , );
rtDeclareVariable ( unsigned int, pt_ray_type , , );

//rtDeclareVariable(float3, ambientcolor, ,);

rtDeclareVariable ( uint2, launch_index, rtLaunchIndex, );
rtDeclareVariable ( uint2, launch_dim, rtLaunchDim, );


rtDeclareVariable ( float, depthSampleX, , );
rtDeclareVariable ( float, depthSampleY, , );
rtDeclareVariable ( unsigned int, realResolutionX, , );
rtDeclareVariable ( unsigned int, realResolutionY, , );
//rtDeclareVariable(unsigned int, samplesPerLaunch, ,);
//rtDeclareVariable(unsigned int, frame, ,);
//rtDeclareVariable(unsigned int, numScrambles, ,);

//rtDeclareVariable(unsigned int, static_render, ,);

rtDeclareVariable ( float, scene_extent, , );

//RT_PROGRAM void exception_program(void) {
//	//	float widthInterval = (float)displayWidth / (float)launch_dim.x;
//	//	float heightInterval = (float)displayHeight / (float)launch_dim.y;
//	//	launch_index = make_uint2((unsigned int)((float)launch_index.x * (widthInterval)),
//	//						  (unsigned int)((float)launch_index.y * (heightInterval)));
//	//	if (rtGetExceptionCode() == RT_EXCEPTION_STACK_OVERFLOW) {
//	optix::float4 theColor = make_float4(100000.f, 0.f, 100000.f, 0.f);
//	output_buffer_directLight[launch_index] = theColor;
//	//		fillBuffer<optix::float4>(launch_index.x, launch_index.y, (unsigned int) widthInterval, (unsigned int) heightInterval, theColor, output_buffer_directLight);
//	//	} else {
//	rtPrintExceptionDetails();
//	//	}
//}

__device__ void reInitializePrd ( PerRayData_pt &p_prd, const float3 &p_origin, const float3 &p_direction, const unsigned int &p_seed, const unsigned int &p_uniformSeed ) {
    p_prd.directIllumination = true;
    p_prd.depth = 1;
    p_prd.seed = p_seed;
    p_prd.uniformSeed = p_uniformSeed;
    p_prd.done = false;
    p_prd.origin = p_origin;
    p_prd.direction = p_direction;
    p_prd.background = false;
    p_prd.dotProduct = 0.f;
    p_prd.pdf = 1.f;
    p_prd.f = make_float3 ( 0.f );
    p_prd.texCol = make_float3 ( 0.f );
    p_prd.radiance = make_float3 ( 0.f );
}

RT_PROGRAM void refocus_camera() {
    optix::float3 directLightingResult = make_float3 ( 0.f );
    unsigned int seed = 0;
    unsigned int uniformSeed = 0;
    //
    //#define BLOCKSIZE_X 8
    //#define BLOCKSIZE_Y 4
    //unsigned int pixelIndex = 0;//launch_index.y * launch_dim.x + launch_index.x;
    //	unsigned int blockIndex = (launch_index.y / BLOCKSIZE_Y) * (launch_index.x / BLOCKSIZE_X) + (launch_index.x) / BLOCKSIZE_X;
    //	optix::float2 dirIncrements = 1.0f / make_float2(launch_dim) * 2.f;
    //	optix::float2 theDir_original = optix::make_float2(launch_index) * dirIncrements - 1.f - dirIncrements * .5f;
    PerRayData_pt prd;
    prd.numCastRays = 0;
    //	unsigned int realFrame = numPreviousFrames * samplesPerLaunch;
    //	for (int i = 0; i < samplesPerLaunch; ++i) {
    //		unsigned int individualSeed = tea<16> (pixelIndex, frame * samplesPerLaunch + i);
    //		unsigned int blockSeed = tea<16> (blockIndex, frame * samplesPerLaunch + i);
    //
    //		unsigned int virtualLaunchIndex_x = launch_index.x + (rnd(blockSeed) * BLOCKSIZE_X);
    //		unsigned int virtualLaunchIndex_y = launch_index.y + (rnd(blockSeed) * BLOCKSIZE_Y);
    //
    //		unsigned int virtualBlockIndex = (virtualLaunchIndex_y / BLOCKSIZE_Y) * (virtualLaunchIndex_x / BLOCKSIZE_X) + (virtualLaunchIndex_x) / BLOCKSIZE_X;
    //
    //		unsigned int r_base = virtualBlockIndex;
    //#define MAX_SEEDS_PER_BLOCK 16
    //
    //		unsigned int r = tea<16>(r_base, (unsigned int)(rnd(individualSeed) * seedsPerBlock) % seedsPerBlock);
    //		r = tea<16>(r, frame * samplesPerLaunch + i);
    //		++realFrame;
    //		unsigned int rrSeed = hash(frame);
    //		optix::float3 throughput = make_float3(1.0f);
    //		optix::float3 unWeightedThroughput = make_float3(1.f);
    //		seed = tea<16> (pixelIndex, frame * samplesPerLaunch + i);
    //		//		seed = r;
    //		uniformSeed = hash(realFrame);
    //
    //		unsigned int realDepth = 1; // how many steps have we really done, including position reset ;)
    //		unsigned int numRestartedRays = 1;
    //
    //		optix::float3 directLightingResult_pass = make_float3(0.f);
    //		float2 theDir = make_float2(theDir_original.x + dirIncrements.x * rnd(seed), theDir_original.y + dirIncrements.y * rnd(seed));
    float2 pixelSample = make_float2 ( depthSampleX, depthSampleY ) * make_float2 ( realResolutionX, realResolutionY ) + make_float2 ( 0.5f, 0.5f );
    float2 d = pixelSample / make_float2 ( realResolutionX, realResolutionY ) * 2.f - 1.f;
    // focal distance and aperture size are normalized values between 0 and 1. they are then scaled by the scene's bounding box!
    float3 theDir = d.x * U + d.y * V + W;
    //		float3 rayTarget = eye + theDir * (focalDist);
    //		float2 sample = optix::square_to_disk(make_float2(rnd(seed), rnd(seed)));
    //		float3 rayOrigin = eye + (apertureRadius * farplane_dist) * (sample.x * optix::normalize(U) + sample.y * optix::normalize(V));
    //		theDir = optix::normalize(rayTarget - rayOrigin);
    reInitializePrd ( prd, eye, theDir, seed, uniformSeed );
    //		prd.realFrame = realFrame;
    //		do {
    //
    //			if ((prd.background || prd.done) && realDepth < maxDepth) {
    //
    //				++realFrame;
    //				prd.realFrame = realFrame;
    //
    //				throughput = make_float3(1.0f);
    //
    //				float2 pixelSample = make_float2(launch_index) + make_float2(rnd(seed), rnd(seed));
    //				float2 d = pixelSample / make_float2(launch_dim) * 2.f - 1.f;
    //
    //				// focal distance and aperture size are normalized values between 0 and 1. they are then scaled by the scene's bounding box!
    //
    //				float3 theDir = d.x * U + d.y * V + W;
    //				float3 rayTarget = eye + theDir * (focalDist);
    //				float2 sample = optix::square_to_disk(make_float2(rnd(seed), rnd(seed)));
    //				float3 rayOrigin = eye + (apertureRadius * farplane_dist) * (sample.x * optix::normalize(U) + sample.y * optix::normalize(V));
    //				theDir = optix::normalize(rayTarget - rayOrigin);
    //
    //				reInitializePrd(prd, eye, theDir, seed, uniformSeed, pixelIndex);
    //
    //				++numRestartedRays;
    //
    //			}
    //
    //			if (!prd.done) {
    //				if (prd.depth > 1) {
    //					prd.origin = getAdjustedRayStart(prd.origin, prd.normal_geometric, scene_epsilon);
    //				}
    optix::Ray ray = optix::make_Ray ( prd.origin, prd.direction, pt_ray_type, scene_epsilon, RT_DEFAULT_MAX );
    //
    prd.dotProduct = 0.f;
    prd.pdf = 0.f;
    prd.f = make_float3 ( 0.f );
    prd.texCol = make_float3 ( 0.f );
    prd.radiance = make_float3 ( 0.f );
    //				rtPrintf("Launching rtTrace in %u, %u!\n", launch_index.x, launch_index.y);
    rtTrace ( top_object, ray, prd );
    output_buffer_centerDepth[0] = prd.background ? scene_extent * 10e7f : prd.hitDist;
    //				++prd.numCastRays;
    //				//
    //				//				if(prd.depth ==	1) {
    //				////					directLightingResult_pass += (prd.normal + make_float3(1.f)) * .5f;
    //				//					prd.hitDist /= farplane_dist;
    //				//					//unsigned int* uint_hitDist = reinterpret_cast<unsigned int*>(&prd.hitDist);
    //				//					//unsigned int r = (0xff0000 & *(uint_hitDist)) >> 16;
    //				//					//unsigned int g = (0x00ff00 & *(uint_hitDist)) >> 8;
    //				//					//unsigned int b = (0x0000ff & *(uint_hitDist));
    //				//					directLightingResult_pass += make_float3(prd.hitDist);
    //				//				}
    //				directLightingResult_pass += fmaxf(make_float3(0.f), prd.radiance * prd.texCol * throughput);
    //				throughput *= prd.texCol * prd.f * prd.dotProduct / prd.pdf;
    //
    //				if (realDepth == 1 && launch_index.x == depthSampleX && launch_index.y == depthSampleY) {
    //					output_buffer_centerDepth[0] = prd.background ? farplane_dist * 100.f: prd.hitDist;
    //				}
    //
    //				//
    //				float r = rnd(rrSeed);
    //				float contProb = 1.f;//prd.depth > 1 ? fminf(1.f, optix::luminance(throughput)) : 1;
    //				if (r > contProb || prd.pdf <= 0.f || fmaxf(throughput) <= 0.f || fmaxf(prd.f) <= 0.f) { // no contribution
    //					prd.done = true;
    //				} else {
    //					throughput /= contProb; // higher contribution
    //				}
    //			}
    //
    //			++prd.depth;
    //			++realDepth;
    //
    //		} while (prd.depth <= maxDepth && !prd.done);
    //
    //		directLightingResult += directLightingResult_pass / numRestartedRays;
    //	}
    //	//	correct errors if they happen, which they should not ;)
    //	directLightingResult = optix::fmaxf(make_float3(0.f), directLightingResult) / samplesPerLaunch;
    //
    //	float4 theResult = make_float4(0.f);
    //
    //	//	if (numPreviousFrames > 0) {
    //
    //	float oldWeight = (float) numPreviousFrames / (float) (numPreviousFrames + 1);
    //	float newWeight = 1.0f - oldWeight;
    //
    //	theResult = oldWeight * output_buffer_directLight[launch_index] + newWeight * optix::make_float4(directLightingResult);
    //	theResult.w = prd.numCastRays;
    //	rtPrintf("%d: ", theResult.w);
    //		output_buffer_directLight[launch_index] = oldWeight * output_buffer_directLight[launch_index] + newWeight * optix::make_float4(directLightingResult);
    //
    //	 else {
    //		output_buffer_directLight[launch_index] = optix::make_float4(directLightingResult);
    //		theResult = optix::make_float4(directLightingResult);
    //		theResult.w = prd.numCastRays;
    //
    //	}
    //	output_buffer_directLight[launch_index] = theResult;
    //	output_buffer_directLight[launch_index] = theResult;
    //	raynum_buffer[launch_index].x = prd.numCastRays;
}
