#include <sobol.h>

#include <optix.h>
#include <assert.h>

void sobol_generate_direction_vectors ( unsigned int vectors[][SOBOL_BITS], int dimensions ) {
    assert ( dimensions <= SOBOL_MAX_DIMENSIONS );
    const unsigned int L = SOBOL_BITS;
    /* first dimension is exception */
    unsigned int *v = vectors[0];

    for ( unsigned int i = 0; i < L; i++ )
    { v[i] = 1 << ( 31 - i ); } // all m's = 1

    for ( int dim = 1; dim < dimensions; dim++ ) {
        SobolDirectionNumbers *numbers = &SOBOL_NUMBERS[dim - 1];
        unsigned int s = numbers->s;
        unsigned int a = numbers->a;
        unsigned int *m = numbers->m;
        v = vectors[dim];

        if ( L <= s ) {
            for ( unsigned int i = 0; i < L; i++ )
            { v[i] = m[i] << ( 31 - i ); }

        } else {
            for ( unsigned int i = 0; i < s; i++ )
            { v[i] = m[i] << ( 31 - i ); }

            for ( unsigned int i = s; i < L; i++ ) {
                v[i] = v[i - s] ^ ( v[i - s] >> s );

                for ( unsigned int k = 1; k < s; k++ )
                { v[i] ^= ( ( ( a >> ( s - 1 - k ) ) & 1 ) * v[i - k] ); }
            }
        }
    }
}