#ifndef _SUB_PROPAGATION_HPP_
#define _SUB_PROPAGATION_HPP_

#include <io/AssimpVBOScene.hpp>
#include <list>

namespace cs {

typedef std::pair<uint, uint> tPrimSub;

bool cmp_sub(const tPrimSub &a, const tPrimSub &b) {
        if(a.first > b.first) return true;
        return false;
}

void propagate(uint* sub, AssimpVBOScene &scene) {
        std::cout << "####PROPAGATING SUBS####"<< std::endl;
        std::list<tPrimSub> sub_table_sort;
        for(int i=0; i < scene.mNbrOfFaces; i++) {
                sub_table_sort.push_back({sub[i], i});
        }
        sub_table_sort.sort(cmp_sub);

        uint current_sub = sub_table_sort.front().first;

        std::list<tPrimSub> left_over;

        while(!sub_table_sort.empty()) {
                tPrimSub front = sub_table_sort.front();
                sub_table_sort.pop_front();

                //Already processed
                if(front.first > current_sub) {
                        continue;
                } else if(front.first == current_sub) {
                        //Check neighbourhood and update subs
                        for(auto const &a : scene.getPrimNeighRel()[front.second]) {
                                //Check self face
                                if(a == front.second) continue;

                                if(sub[a] < current_sub-1) {
                                        sub[a] = current_sub-1;
                                        //std::cout << "Updating sub" << std::endl;
                                        //Add updated subs to left_over;
                                        left_over.push_back({a, sub[a]});
                                }

                        }


                } else {
                        if(left_over.empty()) {
                                current_sub = front.first;
                        } else {
                                std::cout << "Setting sub table" << std::endl;
                                sub_table_sort.insert(sub_table_sort.begin(), left_over.begin(), left_over.end());
                                left_over.clear();
                        }

                }

        }

}

}

#endif
