#ifndef _FILE_SUB_DATA_H_
#define _FILE_SUB_DATA_H_

namespace io {

  namespace data {

    uint32_t magic = 12345666;

    struct HEADER {
      uint32_t width;
      uint32_t height;
      uint32_t max_sub;
      uint64_t sub_table_size;
      uint64_t grid_data_size;
      float scene_bb_min_x, scene_bb_min_y, scene_bb_min_z;
      float scene_bb_max_x, scene_bb_max_y, scene_bb_max_z;
      float uniform_bb_min_x, uniform_bb_min_y, uniform_bb_min_z;
      float uniform_bb_max_x, uniform_bb_max_y, uniform_bb_max_z;
    };

    struct CellData {
      uint32_t x;
      uint32_t y;
      uint32_t z;
      uint32_t level;

      CellData(uint32_t x_, uint32_t y_, uint32_t z_, uint32_t level_) : x(x_), y(y_), z(z_), level(level_) {}
      CellData() : x(0), y(0), z(0), level(0) {}

    };

  }

}

#endif
