#ifndef _GL_ERROR_HANDLER_H_
#define _GL_ERROR_HANDLER_H_

#include <iostream>

#ifdef GL_CHECK_ERRORS
	#define GL_CHECK_ERROR() glCheckError(__LINE__, __FILE__)
#else
	#define GL_CHECK_ERROR()
#endif

bool glCheckError(int line, const char* file) {
	GLenum errCode;
	const GLubyte *errString;

	if ((errCode = glGetError()) != GL_NO_ERROR) {
		errString = gluErrorString(errCode);
		std::cerr << "<" << file << ": " << std::dec << line << ">" << " OpenGL Error: Code 0x" << std::hex << errCode << " : "<< errString << std::endl;

		return true;
	}

	return false;
}


#endif
