#version 450

layout (std140) uniform Material {
    vec4 diffuse;
    vec4 ambient;
    vec4 specular;
    vec4 emissive;
    float shininess;
    int texCount;
};

uniform	sampler2D Texture0;

in vec3 Normal;
in vec2 TexCoord;
flat in unsigned int vidx;
out vec4 resultCol;


layout(binding = 4) uniform atomic_uint dbg_count;

void main()
{
    vec4 color;
    vec4 amb;
    float intensity;
    vec3 lightDir;
    vec3 n;

    lightDir = normalize(vec3(1.0,1.0,1.0));
    n = normalize(Normal);
    intensity = max(dot(lightDir,n),0.0);

    if (texCount == 0) {
        color = diffuse;
        amb = ambient;
    } else {
        color = texture(Texture0, TexCoord);
        amb = color * 0.33;
    }
    resultCol = (color * intensity) + amb;
    atomicCounterIncrement(dbg_count);

    //float id = float(vidx);
    //output = vec4(gl_PrimitiveID / 1000.0,1.0,1.0,1.0);

}
