#version 450

layout (std140) uniform Material {
    vec4 diffuse;
    vec4 ambient;
    vec4 specular;
    vec4 emissive;
    float shininess;
    int texCount;
};

uniform	sampler2D Texture0;

layout(std430, binding=12) buffer SubTable {
    uint sub_table[];
};

in fData {
  vec4 vertexPosWS;
  vec2 TexCoord;
  vec3 Normal;
  flat uint triId;
} frag;


out vec4 resultCol;


void main()
{
    vec4 color;
    vec4 amb;
    float intensity;
    vec3 lightDir;
    vec3 n;

    lightDir = normalize(vec3(1.0,1.0,1.0));
    n = normalize(frag.Normal);
    intensity = max(dot(lightDir,n),0.0);
    //intensity = 0.4f;

    color = vec4(sub_table[frag.triId] / 14.f, 0, 0, 1); //texture(Texture0, frag.TexCoord);
    amb = color * 0.33;

    resultCol = (color * intensity) + amb;


}
