//GEOMETRY SHADER
#version 450

layout (triangles) in;
layout (triangle_strip, max_vertices=3) out;
//layout (line_strip, max_vertices=9) out;

layout (std140) uniform Matrices {
    mat4 projMatrix;
    mat4 viewMatrix;
    mat4 modelMatrix;
};


layout(std430, binding=12) buffer SubTable {
    uint sub_table[];
};


in vData {
  vec4 vertexPos;
  vec2 TexCoord;
  vec3 Normal;
} vertices[];

out fData {
  vec4 vertexPosWS;
  vec2 TexCoord;
  vec3 Normal;
  flat uint triId;
} frag;

//uniform vec3 scene_bb_min;
//uniform vec3 scene_bb_max;

uniform int primitiveIDStartIdx;

//After calling ftTransform in the vertex shader the positions in gl_Position are in eyespace/clipspace
void main()
{


    /////////
    for(int i = 0;i < gl_in.length();i++)
    {
      frag.Normal = vertices[i].Normal;
      frag.TexCoord = vertices[i].TexCoord;
      frag.vertexPosWS = gl_in[i].gl_Position;

      frag.triId = (primitiveIDStartIdx + gl_PrimitiveIDIn);

      //frag.color = vertices[i].color;
      gl_Position = gl_in[i].gl_Position;
      EmitVertex();
    }


    EndPrimitive();
}
