#version 330

layout (std140) uniform Matrices {
    mat4 projMatrix;
    mat4 viewMatrix;
    mat4 modelMatrix;
};

in vec3 position;
in vec3 normal;
in vec2 texCoord;


out vData {
  vec4 vertexPos;
  vec2 TexCoord;
  vec3 Normal;
} vertex;

void main()
{

    vertex.Normal = normalize(vec3(viewMatrix * modelMatrix * vec4(normal,0.0)));
    vertex.TexCoord = vec2(texCoord);
    vertex.vertexPos = vec4(position,1.0);
    //

    //
    gl_Position = projMatrix * viewMatrix * modelMatrix * vec4(position,1.0);
}
