#version 450

layout (std140) uniform Matrices {
    mat4 projMatrix;
    mat4 viewMatrix;
    mat4 modelMatrix;
};


layout(std430, binding=12) buffer SubTable {
    uint sub_table[];
};

in vec3 position;
in vec3 normal;
in vec2 texCoord;

out vData {
  vec4 vertexPos;
  vec2 TexCoord;
  vec3 Normal;
} vertex;


void main()
{

    vertex.Normal = normalize(vec3(viewMatrix * modelMatrix * vec4(normal,0.0)));
    vertex.TexCoord = vec2(texCoord);
  //

mat4 mmodelMatrix;
mat4 mviewMatrix;
mat4 mprojMatrix;

/*
mmodelMatrix[0] = vec4(1, 0, 0, 0);
mmodelMatrix[1] = vec4(0, 1, 0, 0);
mmodelMatrix[2] = vec4(0, 0, 1, 0);
mmodelMatrix[3] = vec4(0, 0, 0, 1);

mviewMatrix[0] = vec4(1, 0, 0, 0);
mviewMatrix[1] = vec4(0, 1, 0, 0);
mviewMatrix[2] = vec4(0, 0, 1, 0);
mviewMatrix[3] = vec4(0, 0, -5, 1);

mprojMatrix[0] = vec4(2, 0, 0, 0);
mprojMatrix[1] = vec4(0, 2, 0, 0);
mprojMatrix[2] = vec4(0, 0, -1.002, -1);
mprojMatrix[3] = vec4(0, 0, -0.2002, 0);



  gl_Position = mprojMatrix * mviewMatrix * vec4(position,1.0);
*/
/*
  mmodelMatrix[0] = vec4(1, 0, 0, 0);
  mmodelMatrix[1] = vec4(0, 1, 0, 0);
  mmodelMatrix[2] = vec4(0, 0, 1, 0);
  mmodelMatrix[3] = vec4(0, 0, 0, 1);

  mviewMatrix[0] = vec4(1, 0, 0, 0);
  mviewMatrix[1] = vec4(0, 1, 0, 0);
  mviewMatrix[2] = vec4(0, 0, 1, 0);
  mviewMatrix[3] = vec4(0, 0, -5, 1);

  mprojMatrix[0] = vec4(2, 0, 0, 0);
  mprojMatrix[1] = vec4(0, 2, 0, 0);
  mprojMatrix[2] = vec4(0, 0, -1.002, -1);
  mprojMatrix[3] = vec4(0, 0, -0.2002, 0);

  gl_Position = projMatrix * viewMatrix * vec4(position,1.0);
*/

    //
  gl_Position = modelMatrix * vec4(position,1.0);
}
