#include <FreeImagePlus.h>
#include <Graph/GraphRunner.h>
#include <Data/DataUtils.h>
#include <cuda.h>

#define FREEIMAGE_COLORORDER=FREEIMAGE_COLORORDER_RGB

int main(int argc, char** argv) {

	FreeImage_Initialise();    

    fipImage image_h;//(FIT_RGBAF, __m_width, __m_height, 128);
    image_h.load(argv[1]);

    uint width = 1024;
    uint height = 1024;

    fipImage targetImage_h(FIT_BITMAP, width, height, 32);





    image_h.convertToRGBAF();

    float4* rawImage_d = 0;
    cudaMalloc(&rawImage_d, sizeof(float4) * width * height);
    cudaMemcpy(rawImage_d, image_h.accessPixels(), sizeof(float4) * width * height, cudaMemcpyHostToDevice);
    // image.accessPixels();

    grip::GraphRunner grunner;
    grunner.init ( argv[3], true, grip::ENUM_GRAPHVISUALIZER_NONE, true);

    grip::dt_UniversalImage_float_4_sptr gripImage(new grip::dt_UniversalImage_float_4_t ( width, height ));


    grip::dt_UniversalImage_float_4_sptr dataSptr = grip::reinterpret_cast_void_sptr<grip::dt_UniversalImage_float_4_sptr> ( gripImage );
    grunner.setParameter<grip::dt_UniversalImage_float_4_sptr> ( "input_color", dataSptr, 1 );
    grunner.setDevicePtr( "input_color", rawImage_d );
    grunner.setDirty ( "input_color", grip::ENUM_COMPENG_CUDA );

    grunner.run();

    grip::dt_UniversalImage_uint8_4_sptr outputImage = grunner.getParameter<grip::dt_UniversalImage_uint8_4_sptr> ( "output_image" );
    outputImage->getDataPointer().get();	

    memcpy(targetImage_h.accessPixels(), outputImage->getDataPointer().get(), sizeof(uint) * width * height);
    targetImage_h.flipVertical();

    // uint* pixelArray = (uint*) (targetImage_h.accessPixels());

    for (int y = 0; y < height; ++y) {
    	for (int x = 0; x < width; ++x) {
    		RGBQUAD col;
    		targetImage_h.getPixelColor(x, y, &col);
    		BYTE r = col.rgbRed;
    		col.rgbRed = col.rgbBlue;
    		col.rgbBlue = r;
    		targetImage_h.setPixelColor(x, y, &col);
    		// uint b = pixelArray[y * width + x] & 0xFF0000;
    		// uint g = pixelArray[y * width + x] & 0x00FF00;
    		// uint r = pixelArray[y * width + x] & 0x0000FF;
    		// b = b >> 16;
    		// r = r >> 0;
    		// uint bnew = r << 16;
    		// uint rnew = b << 0;
    		// pixelArray[y * width + x] = 5115151;//rnew | g | bnew;
    	}
    }

   	targetImage_h.convertTo24Bits();
    targetImage_h.save(argv[2]);

    // __m_grunner.setDevicePtr ( bufferName, ( *__m_devicePointers ) [bufferType] );


    // memcpy(image.accessPixels(), p_buf, sizeof(float4) * __m_width * __m_height);

    // std::stringstream ss;
    // ss << numPreviousFrames;
    // std::string theString = ss.str();
    // std::string theString2 = ss.str();

    // while ( theString.length() < 6 ) {
    //     theString = "0" + theString;
    //     theString2 = "0" + theString2;
    // }

    // std::stringstream ss2_exr;
    // std::stringstream ss2_png;
    // ss2_exr << p_tc.id << "/exr/";
    // ss2_png << p_tc.id << "/png/";

    // theString = p_tc.outputPath + ss2_exr.str() + theString + ".exr";

    // // std::cout << "output path: " << theString << std::endl;
    // // exit(0);

    // image.save(theString.c_str());

    // theString2 = p_tc.outputPath + ss2_png.str() + theString2 + ".png";

    // bool success = image.convertToRGBF();
    // if (!success) {
    //     std::cout << "could not convert 128bit to 96bit image" << std::endl;
    //     exit(1);
    // }

    // success = image.toneMapping(FITMO_REINHARD05);
    // if (!success) {
    //     std::cout << "could not perform tonemapping" << std::endl;
    //     exit(1);
    // }

    // image.save(theString2.c_str());

}